---
title: WebGLRenderingContext.makeXRCompatible()
slug: Web/API/WebGLRenderingContext/makeXRCompatible
tags:
  - 3D
  - API
  - AR
  - Context
  - Mixed
  - Reality
  - Reference
  - VR
  - Virtual
  - WebGL
  - WebGL API
  - WebGLRenderingContext
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRWebGLLayer
  - augmented
  - makeXRCompatible
---
<p>{{APIRef("WebGL")}}</p>

<p>The {{domxref("WebGLRenderingContext")}} method <code><strong>makeXRCompatible()</strong></code> ensures that the rendering context described by the <code>WebGLRenderingContext</code> is ready to render the scene for the immersive <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR</a> device on which it will be displayed. If necessary, the <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> layer may reconfigure the context to be ready to render to a different device than it originally was.</p>

<p>This is useful if you have an application which can start out being presented on a standard 2D display but can then be transitioned to a 3D immersion system.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>makeCompatPromise</em> = <em>webGLRenderingContext</em>.makeXRCompatible();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise">Promise</a></code> which successfully resolves once the WebGL context is ready to be used for rendering <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR</a> content.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method doesn't throw traditional exceptions; instead, the promise rejects with one of the following errors as the value passed into the rejection handler:</p>

<dl>
 <dt><code>AbortError</code></dt>
 <dd>Switching the context over to the WebXR-compatible context failed.</dd>
 <dt><code>InvalidStateError</code></dt>
 <dd>The WebGL context has been lost or there is no available WebXR device.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>Because <code>makeXRCompatible()</code> may involve replacing the underlying WebGL context with a new one that uses the new rendering hardware, the existing contents of the context may be lost and, therefore, would need to be re-rendered. This is why the <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/webglcontextlost_event">webglcontextlost</a></code> and <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/webglcontextrestored_event">webglcontextrestored</a></code> events are used: the first gives you the opportunity to discard anything you won't need anymore, while the second gives you the opportunity to load resources and prepare to render the scene in its new context.</p>

<p>While this method is available through the {{domxref("WebGLRenderingContext")}} interface, it's actually defined by the <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a> rather than by WebGL.</p>

<h2 id="Examples">Examples</h2>

<p>This example demonstrates code logic you might find in a game that starts up using WebGL to display menus and other UI, and uses WebGL to render gameplay, but has a button on its main menu that offers an option to start the game in WebXR mode.</p>

<h3 id="HTML">HTML</h3>

<p>The HTML for the buttons looks lke this:</p>

<pre class="brush: html">&lt;button class="green button" type="button"&gt;Start Game&lt;/button&gt;
&lt;button class="blue button use-webxr" type="button"&gt;Start Game (VR mode)&lt;/button&gt;
</pre>

<p>The first button starts the game, continuing to present the game onscreen as usual. The second button will be used to start the game in <code>immersive-vr</code> mode. Note the inclusion of a <code>use-webxr</code> class on the VR mode button. This is important, which we'll explore shortly.</p>

<h3 id="JavaScript">JavaScript</h3>

<p>The code that handles starting up graphics, switching to VR mode, and so forth looks like this:</p>

<pre class="brush: js">const outputCanvas = document.querySelector(".output-canvas");
const gl = outputCanvas.getContext("webgl");
let xrSession = null;
let usingXR = false;
let currentScene = "scene1";
let glStartButton;
let xrStartButton;

window.addEventListener("load", (event) =&gt; {
  loadSceneResources(currentScene);

  glStartButton.addEventListener("click", handleStartButtonClick);
  xrStartButton.addEventListener("click", handleStartButtonClick);
});

outputCanvas.addEventListener("webglcontextlost", (event) =&gt; {
  /* The context has been lost but can be restored */
  event.canceled = true;
});

/* When the GL context is reconnected, reload the resources for the
   current scene. */
outputCanvas.addEventListener("webglcontextrestored", (event) =&gt; {
  loadSceneResources(currentScene);
});

async function onStartedXRSession(xrSession) {
  try {
    await gl.makeXRCompatible();
  } catch(err) {
    switch(err) {
      case AbortError:
        showSimpleMessageBox("Unable to transfer the game to your XR headset.", "Cancel");
        break;
      case InvalidStateError:
        showSimpleMessageBox("You don't appear to have a compatible XR headset available.", "Cancel");
        break;
      default:
        handleFatalError(err);
        break;
    }
    xrSession.end();
  }
}

async function handleStartButtonClick(event) {
  if (event.target.classList.contains("use-webxr") &amp;&amp; navigator.xr) {
    try {
      xrSession = await navigator.xr.requestSession("immersive-vr");
      usingXR = true;
    } catch(err) {
      xrSession = NULL;
      usingXR = false;
    }
  }
  startGame();
}

function startGame() {
  currentScene = "scene1";
  loadSceneResources(currentScene);

  /* and so on */
}
</pre>

<p>This works by having two buttons, one which starts the game normally and the other which starts the game in VR mode. These both use the <code>handleStartButtonClick()</code> function as their event handler. The function determines that the button clicked was the one requesting <code>immersive-vr</code> mode by checking to see if the button has the <code>use-webxr</code> class on it. If the button clicked by the user has that class (and we've confirmed that WebXR is available by ensuring that the {{domxref("navigator.xr")}} property exists), we use {{domxref("XRSystem.requestSession", "requestSession()")}} to request a new WebXR session and set the <code>usingXR</code> flag to <code>true</code>.</p>

<p>If the other button was clicked, we ensure that <code>xrSession</code> is <code>NULL</code> and clear <code>usingXR</code> to <code>false</code>.</p>

<p>Then the <code>startGame()</code> function is called to trigger the beginning of gameplay.</p>

<p>Handlers are provided for both <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/webglcontextlost_event">webglcontextlost</a></code> and <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/webglcontextrestored_event">webglcontextrestored</a></code>; in the first case, we make sure we're aware that the state can be recovered, while in the latter we actually reload the scene to ensure we have the correct resources for the current screen or headset configuration.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-webglrenderingcontextbase-makexrcompatible","WebGLRenderingContext.makeXRCompatible()")}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WebGLRenderingContext.makeXRCompatible")}}</p>
